<?php
/**
 * @version		1.3.0
 * @package		Joomla
 * @subpackage	Helpdesk Pro
 * @author  Tuan Pham Ngoc
 * @copyright	Copyright (C) 2013 Ossolution Team
 * @license		GNU/GPL, see LICENSE.php
 */
// no direct access
defined('_JEXEC') or die();

OSFactory::loadLibrary('controller');

/**
 * OS Membership controller
 *
 * @package		Joomla
 * @subpackage	Helpdesk Pro
 * @since 1.5
 */
class HelpdeskproControllerTicket extends OSController
{

	/**
	 * Constructor function
	 *
	 * @param array $config
	 */
	function __construct($config = array())
	{
		parent::__construct($config);
	}

	function add()
	{
		JRequest::setVar('layout', 'form');
		parent::add();
	}

	/**
	 * Save the category
	 *
	 */
	function save()
	{
		jimport('joomla.filesystem.file');
		$config = HelpdeskProHelper::getConfig();
		$app = JFactory::getApplication();
		if ($config->enable_captcha && $app->isSite())
		{
			$session = JFactory::getSession();
			$securityCode = JRequest::getVar('security_code', '', 'post');
			if ($securityCode != $session->get('security_code'))
			{
				JRequest::setVar('view', 'ticket');
				JRequest::setVar('layout', 'form');
				JRequest::setVar('captcha_invalid', 1);
				$this->display();
				return;
			}
			$session->clear('security_code');
		}
		$post = JRequest::get('post', JREQUEST_ALLOWRAW);
		$model = $this->getModel('ticket');
		$ret = $model->store($post);
		if ($ret)
		{
			$msg = JText::_('HDP_TICKET_SUBMITTED');
		}
		else
		{
			$msg = JText::_('HDP_ERROR_SAVING_TICKET');
		}
		if ($app->isAdmin())
			$this->setRedirect('index.php?option=com_helpdeskpro&view=tickets', $msg);
		else
		{
			$user = JFactory::getUser();
			$itemId = HelpdeskProHelper::getItemid();
			if (!$user->id)
			{
				$this->setRedirect(
					'index.php?option=com_helpdeskpro&view=ticket&ticket_code=' . $post['ticket_code'] . '&Itemid=' . $itemId, $msg);
			}
			else
			{
				$this->setRedirect('index.php?option=com_helpdeskpro&view=tickets&Itemid=' . $itemId, $msg);
			}
		}
	}

	function add_comment()
	{
		$app = JFactory::getApplication();
		$config = HelpdeskProHelper::getConfig();
		if ($config->enable_captcha && $app->isSite())
		{
			$session = JFactory::getSession();
			$securityCode = JRequest::getVar('security_code', '', 'post');
			if ($securityCode != $session->get('security_code'))
			{
				JRequest::setVar('view', 'ticket');
				JRequest::setVar('layout', 'default');
				JRequest::setVar('id', (int) $post['cid'][0]);
				JRequest::setVar('captcha_invalid', 1);
				$this->display();
				return;
			}
			$session->clear('security_code');
		}
		$post = JRequest::get('post', JREQUEST_ALLOWRAW);
		$post['ticket_id'] = (int) $post['cid'][0];
		$model = $this->getModel('ticket');
		$ret = $model->addComment($post);
		if ($ret)
		{
			$msg = JText::_('HDP_COMMENT_ADDED');
		}
		else
		{
			$msg = JText::_('HDP_ERROR_ADDING_COMMENT');
		}
		$itemId = HelpdeskProHelper::getItemid();
		if (isset($post['ticket_code']))
		{
			$url = 'index.php?option=com_helpdeskpro&view=ticket&ticket_code=' . $post['ticket_code'] . '&Itemid=' . $itemId;
			$this->setRedirect($url, $msg);
		}
		else
		{
			if ($app->isAdmin())
			{
				$this->setRedirect('index.php?option=com_helpdeskpro&view=ticket&id=' . $post['ticket_id'], $msg);
			}
			else
			{				
				$this->setRedirect('index.php?option=com_helpdeskpro&view=ticket&id=' . $post['ticket_id'] . '&Itemid=' . $itemId, $msg);
			}
		}
	}

	function update_category()
	{
		$app = JFactory::getApplication();
		$itemId = HelpdeskProHelper::getItemid();
		$post = JRequest::get('post', JREQUEST_ALLOWRAW);
		$post['id'] = (int) $post['cid'][0];
		$model = $this->getModel('ticket');
		$ret = $model->updateCategory($post);
		if ($ret)
		{
			$msg = JText::_('HDP_TICKET_CATEGORY_UPDATED');
		}
		else
		{
			$msg = JText::_('HDP_ERROR_UPDATE_TICKET_CATEGORY');
		}
		if (isset($post['ticket_code']))
		{
			$url = 'index.php?option=com_helpdeskpro&view=ticket&ticket_code=' . $post['ticket_code'] . '&Itemid=' . $itemId;
			$this->setRedirect($url);
		}
		else
		{
			if ($app->isAdmin())
				$this->setRedirect('index.php?option=com_helpdeskpro&view=ticket&id=' . $post['id'], $msg);
			else
				$this->setRedirect('index.php?option=com_helpdeskpro&view=ticket&id=' . $post['id'] . '&Itemid=' . $itemId, $msg);
		}
	}

	function update_status()
	{
		$app = JFactory::getApplication();
		$itemId = HelpdeskProHelper::getItemid();
		$post = JRequest::get('post', JREQUEST_ALLOWRAW);
		$post['id'] = (int) $post['cid'][0];
		$model = $this->getModel('ticket');
		$ret = $model->updateStatus($post);
		if ($ret)
		{
			$msg = JText::_('HDP_TICKET_STATUS_UPDATED');
		}
		else
		{
			$msg = JText::_('HDP_ERROR_UPDATING_TICKET_STATUS');
		}
		if (isset($post['ticket_code']))
		{
			$url = 'index.php?option=com_helpdeskpro&view=ticket&ticket_code=' . $post['ticket_code'] . '&Itemid=' . $itemId;
			$this->setRedirect($url, $msg);
		}
		else
		{
			if ($app->isAdmin())
				$this->setRedirect('index.php?option=com_helpdeskpro&view=ticket&id=' . $post['id'], $msg);
			else
				$this->setRedirect('index.php?option=com_helpdeskpro&view=ticket&id=' . $post['id'] . '&Itemid=' . $itemId, $msg);
		}
	}

	function update_priority()
	{
		$app = JFactory::getApplication();
		$itemId = HelpdeskProHelper::getItemid();
		$post = JRequest::get('post', JREQUEST_ALLOWRAW);
		$post['id'] = (int) $post['cid'][0];
		$model = $this->getModel('ticket');
		$ret = $model->updatePriority($post);
		if ($ret)
		{
			$msg = JText::_('HDP_TICKET_PRIORITY_UPDATED');
		}
		else
		{
			$msg = JText::_('HDP_ERROR_UPDATING_PRIORITY');
		}
		if (isset($post['ticket_code']))
		{
			$url = 'index.php?option=com_helpdeskpro&view=ticket&ticket_code=' . $post['ticket_code'] . '&Itemid=' . $itemId;
			$this->setRedirect($url);
		}
		else
		{
			if ($app->isAdmin())
			{
				$this->setRedirect('index.php?option=com_helpdeskpro&view=ticket&id=' . $post['id'], $msg);
			}
			else
			{
				$this->setRedirect('index.php?option=com_helpdeskpro&view=ticket&id=' . $post['id'] . '&Itemid=' . $itemId, $msg);
			}
		}
	}

	function apply_label()
	{
		$app = JFactory::getApplication();
		$post = JRequest::get('post', JREQUEST_ALLOWRAW);
		$post['id'] = (int) $post['cid'][0];
		$model = $this->getModel('ticket');
		$ret = $model->applyLabel($post);
		if ($ret)
		{
			$msg = JText::_('HDP_TICKET_LABEL_UPDATED');
		}
		else
		{
			$msg = JText::_('HDP_ERROR_UPDATING_TICKET_LABEL');
		}
		$this->setRedirect('index.php?option=com_helpdeskpro&view=ticket&id=' . $post['id'], $msg);
	}

	/**
	 * Save rating and close the ticket
	 */
	function save_rating()
	{
		$app = JFactory::getApplication();
		$itemId = HelpdeskProHelper::getItemid();
		$post = JRequest::get('post', JREQUEST_ALLOWRAW);
		$post['id'] = (int) $post['cid'][0];
		$model = $this->getModel('ticket');
		$ret = $model->saveRating($post);
		if ($ret)
		{
			$msg = JText::_('HDP_RATING_SAVED');
		}
		else
		{
			$msg = JText::_('HDP_ERROR_SAVING_RATING');
		}
		if (isset($post['ticket_code']))
		{
			$url = 'index.php?option=com_helpdeskpro&view=ticket&ticket_code=' . $post['ticket_code'] . '&Itemid=' . $itemId;
			$this->setRedirect($url);
		}
		else
		{
			if ($app->isAdmin())
			{
				$this->setRedirect('index.php?option=com_helpdeskpro&view=ticket&id=' . $post['id'], $msg);
			}
			else
			{
				$this->setRedirect('index.php?option=com_helpdeskpro&view=ticket&id=' . $post['id'] . '&Itemid=' . $itemId, $msg);
			}
		}
	}

	/**
	 * send Email assing tickket
	 */
	function assign_ticket()
	{
		$db = JFactory::getDbo();
		$user = JFactory::getUser();
		$query = $db->getQuery(true);
		$userId = JRequest::getInt('user_id');
		$id = JRequest::getInt('id');
		if ($id)
		{
			//update user id ticket
			$query->update("#__helpdeskpro_tickets")
				->set("staff_id=" . (int) $userId)
				->where("id=" . $id);
			$db->setQuery($query);
			$db->query();
			if ($userId > 0)
			{
				//get email user assign
				$query->clear();
				$query->select('name, email')
					->from('#__users')
					->where('id=' . (int) $userId);
				$db->setQuery($query);
				$staff = $db->loadObject();

				$query->clear();
				$query->select('a.*, b.title AS category_title')
					->from('#__helpdeskpro_tickets AS a')
					->innerJoin('#__helpdeskpro_categories AS b ON a.category_id = b.id')
					->where('a.id = '. $id);
				$db->setQuery($query);
				$row = $db->loadObject();
				//send email ticket

				$message = HelpdeskProHelper::getEmailMessages();
				$config = HelpdeskProHelper::getConfig();
				if ($config->from_email)
				{
					$fromEmail = $config->from_email;
				}
				else
				{
					$fromEmail = JFactory::getConfig()->get('mailfrom');
				}
				if ($config->from_name)
				{
					$fromName = $config->from_name;
				}
				else
				{
					$fromName = JFactory::getConfig()->get('fromname');
				}
				$subject = $message->ticket_assiged_email_subject;
				$body = $message->ticket_assiged_email_body;
				$replaces = array();
				$replaces['STAFF_NAME'] = $staff->name;
				$replaces['MANAGER_NAME'] = $user->name;
				$replaces['TICKET_ID'] = $id;
				$replaces['TICKET_SUBJECT'] = $row->subject;
				$replaces['CATEGORY_TITLE'] = $row->category_title;
				foreach ($replaces as $key => $value)
				{
					$key = strtoupper($key);
					$body = str_replace("[$key]", $value, $body);
					$subject = str_replace("[$key]", $value, $subject);
				}
				$mailer = JFactory::getMailer();
				$mailer->sendMail($fromEmail, $fromName, $staff->email, $subject, $body, true);
			}
		}
	}
	/**
	 * Download an attachment from the ticket
	 */
	function download_attachment()
	{
		$fileName = JRequest::getVar('filename', '');
		$originalFilename = JRequest::getVar('original_filename', '');
		if (file_exists(JPATH_ROOT . '/media/com_helpdeskpro/attachments/' . $fileName))
		{
			while (@ob_end_clean());
			HelpdeskProHelper::processDownload(JPATH_ROOT . '/media/com_helpdeskpro/attachments/' . $fileName, $originalFilename);
			exit();
		}
		else
		{
			$mainframe = JFactory::getApplication();
			$mainframe->redirect('index.php', JText::_('HDP_FILE_NOT_EXIST'));
		}
	}
}